#ifndef GUILA_H
#define GUILA_H 1

#include "gui.h"

typedef struct {
	guiNativeHandle c;
	char *text;
} guiLabel, *guiLabelPtr;

/* Returns the size in pixels necessary to render
	the specified label without scrollbars
	in a single row. */

guiSize guiLabelEstimate(char *text);

/* Returns the height in pixels necessary to render
	the specified label without scrollbars if the 
	label is given the specified width in pixels. */

int guiLabelEstimateHeight(char *text, int width);

guiLabelPtr guiLabelCreate(guiCanvasPtr parent,
	int x, int y, char *text);

guiLabelPtr guiLabelCreateWithSize(guiCanvasPtr parent,
	int x, int y, int w, int h, char *text);

void guiLabelDestroy(guiLabelPtr l);

void guiLabelShow(guiLabelPtr l, int flag);

void guiLabelSetText(guiLabelPtr l, char *newtext);

void guiLabelSetPhysicalSize(guiLabelPtr l, int w, int h);

void guiLabelMove(guiLabelPtr l, int x, int y);

guiSize guiLabelGetPhysicalSize(guiLabelPtr l);

extern guiFont guiLabelFont;

/* Color for the text. The background is guiDefaultBackgroundColor. */
extern guiColor guiLabelColor;

#endif /* GUILA_H */

