#include <stdio.h>

int main(int argc, char *argv[])
{
	char *from;
	char *to;
	FILE *in;
	FILE *out;
	int ch;
	int pos = 0;
	int len = 0;
	char *symbol;
	int first = 1;
	/* Converts PNG files to C source code suitable
		for linking into your code and reading with
		guiBitmapLoadBuiltin(). */
	
	if (argc >= 3) {
		from = argv[1];
		in = fopen(from, "rb");
		if (!in) {
			fprintf(stderr, "Can't access file %s\n", from);
			exit(1);
		}
		if (argc >= 4) {
			to = argv[2];
			if (argc >= 5) {
				fprintf(stderr, "Usage: guires [file.png] [file.c] bitmapname\n");	
				exit(1);
			}
			out = fopen(to, "wb");
			if (!out) {
				fprintf(stderr, "Can't access file %s\n", from);
				exit(1);
			}
		} else {
			out = stdout;
		}
	} else {
		in = stdin;
		out = stdout;
	}
	if (argc < 2) {
		fprintf(stderr, "Usage: guires [file.png] [file.c] bitmapname\n");	
		exit(1);
	}
	symbol = argv[argc - 1];
	fprintf(out, "unsigned char %s[] = {\n\t", symbol);
	while(1) {
		ch = getc(in);
		if (ch == EOF) {
			break;
		}	
		if (!first) {
			fprintf(out, ", ");
		}
		first = 0;
		if (pos >= 60) {
			fprintf(out, "\n\t");
			pos = 0;
		}
		fprintf(out, "0x%.2x", ch);
		pos += 6;
		len++;
	}
	fprintf(out, "\n};\n\n");
	fprintf(out, "int %sSize = %d;\n\n", symbol, len);
	return 0;
}

