#include "gui.h"
#include "guix.h"
#include "guixb.h"

#include <stdlib.h>
#include <stddef.h>
#include "jpeglib.h"
#include "png.h"
#include "gd.h"

guiBitmapPtr guiXBitmapLoadGif(FILE *in, int dither) 
{
	gdImagePtr im;
	int x, y;
	guiBitmapPtr r;
	guiColor c;
return 0;
}

#ifndef __hpux
guiBitmapPtr guiXBitmapLoadGif(FILE *in, int dither) {
	gdImagePtr im;
	int x, y;
	guiBitmapPtr r;
	guiColor c;
	im = gdImageCreateFromGif(in);
	if (!im) { 
		return 0;
	}
	r = guiXBitmapCreate(im->sx, im->sy);
	if (!r) {
		gdImageDestroy(im);
		return 0;
	}
	for (y = 0; (y < r->s.h); y++) {
		c.r = (rand() >> 4) & 0x0f;
		c.g = (rand() >> 4) & 0x0f;
		c.b = (rand() >> 4) & 0x0f; 
		if (dither) {
			for (x = 0; (x < r->s.w); x++) {
				guiColor try;
				c.r += gdImageRed(im, gdImageGetPixel(im, x, y));
				c.g += gdImageGreen(im, gdImageGetPixel(im, x, y));
				c.b += gdImageBlue(im, gdImageGetPixel(im, x, y));
				try = c;
				XPutPixel((XImage *) r->handle,
					x, y, guiXColorGet(&try));
				c.r -= try.r;
				c.g -= try.g;
				c.b -= try.b; 
			}
		} else {			
			for (x = 0; (x < r->s.w); x++) {
				guiColor try;
				try.r = gdImageRed(im, gdImageGetPixel(im, x, y));
				try.g = gdImageGreen(im, gdImageGetPixel(im, x, y));
				try.b = gdImageBlue(im, gdImageGetPixel(im, x, y));
				XPutPixel((XImage *) r->handle,
					x, y, guiXColorGet(&try));
			}
		}
	}
	gdImageDestroy(im);
	r->sourceType = guiBitmapGif;
	return r;
}
#endif

struct my_error_mgr {
  struct jpeg_error_mgr pub;	/* "public" fields */

  jmp_buf setjmp_buffer;	/* for return to caller */
};

typedef struct my_error_mgr * my_error_ptr;

/*METHODDEF*/ void
my_error_exit (j_common_ptr cinfo)
{
  /* cinfo->err really points to a my_error_mgr struct, so coerce pointer */
  my_error_ptr myerr = (my_error_ptr) cinfo->err;

  /* Always display the message. */
  /* We could postpone this until after returning, if we chose. */
  (*cinfo->err->output_message) (cinfo);

  /* Return control to the setjmp point */
  longjmp(myerr->setjmp_buffer, 1);
}

/*METHODDEF*/ void
my_output_message (j_common_ptr cinfo)
{
  char buffer[JMSG_LENGTH_MAX];

  /* Create the message */
  (*cinfo->err->format_message) (cinfo, buffer);
  guiMessage(0, "JPEG Error", buffer, guiMessageOK);
}

guiBitmapPtr guiXBitmapLoadJpeg(FILE *in, int dither) 
{
	struct jpeg_decompress_struct cinfo;
	struct my_error_mgr jerr;
	guiBitmapPtr r = 0;
	int x, y;
	JSAMPLE *scanline;
	guiColor c;
	cinfo.err = jpeg_std_error(&jerr.pub);
	jerr.pub.output_message = my_output_message;
	jerr.pub.error_exit = my_error_exit;
	/* Establish the setjmp return context for my_error_exit to use. */
	if (setjmp(jerr.setjmp_buffer)) {
		/* If we get here, the JPEG code has signaled an error.
			We need to clean up the JPEG object, close the input 
			file, and return.  */
		jpeg_destroy_decompress(&cinfo);
		if (scanline) {
			free(scanline);
		}
		if (r) {
			if (r->handle) {
				XDestroyImage((XImage *) r->handle);
			}
			free(r);
		}
		return 0;
	}
	jpeg_create_decompress(&cinfo);
	jpeg_stdio_src(&cinfo, in);
	jpeg_read_header(&cinfo, 1);
	jpeg_start_decompress(&cinfo);
	
	scanline = (JSAMPLE *) malloc(
		cinfo.output_width * cinfo.output_components *
		sizeof(JSAMPLE));

	if (!scanline) {
		jpeg_destroy_decompress(&cinfo);
		return 0;
	}    

	r = guiXBitmapCreate(cinfo.output_width, cinfo.output_height);
	if (!r) {
		jpeg_destroy_decompress(&cinfo);
		free(scanline);
		return 0;
	}
	y = cinfo.output_scanline;	
	while (cinfo.output_scanline < cinfo.output_height) 
	{
		unsigned char *scanlineC = scanline;
		if (jpeg_read_scanlines(&cinfo, &scanline, 1) < 1) 
		{
			break;
		}
		c.r = (rand() >> 4) & 0x0f; 
		c.g = (rand() >> 4) & 0x0f; 
		c.b = (rand() >> 4) & 0x0f; 
		if (cinfo.output_components == 3) {
			if (dither) {
				for (x = 0; (x < r->s.w); x++) {
					guiColor try;
					c.r += *scanlineC++;
					c.g += *scanlineC++;
					c.b += *scanlineC++;
					try = c;
					XPutPixel((XImage *) r->handle,
						x, y, guiXColorGet(&try));
					c.r -= try.r;
					c.g -= try.g;
					c.b -= try.b;
				}		
			} else {	
				for (x = 0; (x < r->s.w); x++) {
					guiColor try;
					try.r = *scanlineC++;
					try.g = *scanlineC++;
					try.b = *scanlineC++;
					XPutPixel((XImage *) r->handle,
						x, y, guiXColorGet(&try));
				}		
			}
		} else {
			if (dither) {	
				for (x = 0; (x < r->s.w); x++) {
					guiColor try;
					c.r += *scanlineC;
					c.g += *scanlineC;
					c.b += *scanlineC++;
					try = c;
					XPutPixel((XImage *) r->handle,
						x, y, guiXColorGet(&try));
					c.r -= try.r;
					c.g -= try.g;
					c.b -= try.b;
				}				
			} else {	
				for (x = 0; (x < r->s.w); x++) {
					guiColor try;
					try.r = *scanlineC;
					try.g = *scanlineC;
					try.b = *scanlineC++;
					XPutPixel((XImage *) r->handle,
						x, y, guiXColorGet(&try));
				}				
			}
		}
		y = cinfo.output_scanline;
	}	
	jpeg_finish_decompress(&cinfo);		
	jpeg_destroy_decompress(&cinfo);
	free(scanline);
	r->sourceType = guiBitmapJpeg;
	return r;
}

extern void PngMessage(char *msg);

void PngMessage(char *msg)
{
	guiMessage(0, "PNG Error", msg, guiMessageOK);
}

typedef struct {
	png_bytep data;
	png_uint_32 pos;
} resourceIO, *resourceIOPtr;

static void resourceRead(png_structp png_ptr, 
	png_bytep data, 
	png_uint_32 length)
{
	resourceIOPtr r = (resourceIOPtr) png_ptr->io_ptr; 
	memcpy(data, r->data + r->pos, length);
	r->pos += length;	
}

guiBitmapPtr guiXBitmapLoadPng(FILE *in, unsigned char *resource, int dither)
{
	unsigned char **scanlines;
	float screen_gamma = 2.0;
	int number_passes;
	int pass; 
	int i;
	guiBitmapPtr r = 0;
	png_struct *png_ptr;
	png_info *info_ptr;
	png_color_16 my_background;
	resourceIO io;
	/* allocate the necessary structures */
	png_ptr = (png_struct *) malloc(sizeof (png_struct));
	if (!png_ptr)
	{          
		return 0;
	}

	info_ptr = (png_info *) malloc(sizeof (png_info));
	if (!info_ptr)
	{
		free(png_ptr);
		return 0;
	}
	/* set error handling */
	if (setjmp(png_ptr->jmpbuf))
	{
		png_read_destroy(png_ptr, info_ptr, (png_info *)0);
		free(png_ptr);
		free(info_ptr);
		if (r) {
			guiBitmapDestroy(r);
		}
		/* If we get here, we had a problem reading the file */
		return 0;
	}
	/* initialize the structures, info first for error handling */
	png_info_init(info_ptr);
	png_read_init(png_ptr);

	if (in) {
		/* set up the input control */
		png_init_io(png_ptr, in);
	} else if (resource) {
		io.data = (png_bytep) resource;
		io.pos = 0;	
		png_set_read_fn(png_ptr, (png_voidp) &io, resourceRead);
	} else {
		png_error(png_ptr, "Neither a file nor a resource data "
				"pointer was provided to read from.");
	}	
	/* read the file information */
	png_read_info(png_ptr, info_ptr);

	scanlines = (unsigned char **) malloc(sizeof(unsigned char *) * 
		(long)info_ptr->height);
	if (!scanlines) {
		png_read_destroy(png_ptr, info_ptr, (png_info *)0);
		free(png_ptr);
		free(info_ptr);
		return 0;
	}
	for (i=0; (i < info_ptr->height); i++) {
		scanlines[i] = (unsigned char *) malloc(info_ptr->width * 3 + 4);
		if (!scanlines[i]) {
			int j;
			for (j = 0; (j < i); j++) {
				free(scanlines[j]);
			}
			free(scanlines);
			png_read_destroy(png_ptr, info_ptr, (png_info *)0);
			free(png_ptr);
			free(info_ptr);
			return 0;
		}
	}
	png_set_expand(png_ptr);
	png_set_gray_to_rgb(png_ptr);

	/* Set the background color to draw transparent and alpha
		images over */
	my_background.red = my_background.green = my_background.blue = 0x0000;

	if (info_ptr->valid & PNG_INFO_bKGD) {
		png_set_background(png_ptr, &(info_ptr->background),
			PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
	} else {
		png_set_background(png_ptr, &my_background,
			PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
	}
	/* tell libpng to handle the gamma conversion for you */
	if (info_ptr->valid & PNG_INFO_gAMA) {
		png_set_gamma(png_ptr, screen_gamma, info_ptr->gamma);
	} else {
		png_set_gamma(png_ptr, screen_gamma, 0.45);
	}
	/* tell libpng to strip 16 bit depth files down to 8 bits */
	if (info_ptr->bit_depth == 16) {
		png_set_strip_16(png_ptr);
	}
	/* turn on interlace handling if you are not using png_read_image() */
	if (info_ptr->interlace_type) {
		number_passes = png_set_interlace_handling(png_ptr);
	} else {
		number_passes = 1;
	}
	/* optional call to update palette with transformations */
	png_start_read_image(png_ptr);

	/* optional call to update the info structure */
	png_read_update_info(png_ptr, info_ptr);

	r = guiXBitmapCreate(info_ptr->width, info_ptr->height);
	if (!r) {
		int j;
		for (j = 0; (j < i); j++) {
			free(scanlines[j]);
		}
		free(scanlines);
		png_read_destroy(png_ptr, info_ptr, (png_info *)0);
		free(png_ptr);
		free(info_ptr);
		return 0;
	}	
	for (pass = 0; pass < number_passes; pass++) {
		guiColor c;
		unsigned long y;
		for (y = 0; y < info_ptr->height; y++) {
			int x;
			unsigned char *scanlineC = scanlines[y];
			png_read_rows(png_ptr, &scanlineC, NULL, 1);
			/* No need to examine the output of incomplete passes */
			if (pass != (number_passes - 1)) {
				continue;
			}
			c.r = (rand() >> 4) & 0x0f; 
			c.g = (rand() >> 4) & 0x0f; 
			c.b = (rand() >> 4) & 0x0f; 
			if (dither) {
				for (x = 0; (x < r->s.w); x++) {
					guiColor try;
					c.r += *scanlineC++;
					c.g += *scanlineC++;
					c.b += *scanlineC++;
					try = c;
					XPutPixel((XImage *) r->handle,
						x, y, guiXColorGet(&try));
					c.r -= try.r;
					c.g -= try.g;
					c.b -= try.b;
				}		
			} else {				
				for (x = 0; (x < r->s.w); x++) {
					guiColor try;
					try.r = *scanlineC++;
					try.g = *scanlineC++;
					try.b = *scanlineC++;
					XPutPixel((XImage *) r->handle,
						x, y, guiXColorGet(&try));
				}		
			}
		}
	}
	/* read the rest of the file, getting any additional chunks
		in info_ptr */
	png_read_end(png_ptr, info_ptr);

	/* Free the image buffer */
	for (i=0; (i < info_ptr -> height); i++) {
		free(scanlines[i]);
	}
	free(scanlines);   
   
	/* clean up after the read, and free any memory allocated */
	png_read_destroy(png_ptr, info_ptr, (png_info *)0);

	/* free the structures */
	free(png_ptr);
	free(info_ptr);
	/* that's it */
	r->sourceType = guiBitmapPng;
	return r;
}

